(function (global, factory) {
	typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@harmowatch/redux-decorators'), require('rxjs/add/operator/distinctUntilChanged'), require('@angular/core'), require('rxjs/add/operator/map'), require('rxjs/ReplaySubject'), require('rxjs/add/operator/toPromise'), require('rxjs/AsyncSubject'), require('rxjs/Observable'), require('@angular/common'), require('rxjs/add/operator/takeWhile'), require('rxjs/BehaviorSubject'), require('redux')) :
	typeof define === 'function' && define.amd ? define(['exports', '@harmowatch/redux-decorators', 'rxjs/add/operator/distinctUntilChanged', '@angular/core', 'rxjs/add/operator/map', 'rxjs/ReplaySubject', 'rxjs/add/operator/toPromise', 'rxjs/AsyncSubject', 'rxjs/Observable', '@angular/common', 'rxjs/add/operator/takeWhile', 'rxjs/BehaviorSubject', 'redux'], factory) :
	(factory((global.harmowatch = global.harmowatch || {}, global.harmowatch['ngx-redux-core'] = {}),global.reduxDecorators,global.Rx.Observable.prototype,global.ng.core,global.Rx.Observable.prototype,global.Rx,global.Rx.Observable.prototype,global.Rx,global.Rx,global.ng.common,global.Rx.Observable.prototype,global.Rx,global.redux));
}(this, (function (exports,reduxDecorators,distinctUntilChanged,core,map,ReplaySubject,toPromise,AsyncSubject,Observable,common,takeWhile,BehaviorSubject,redux) { 'use strict';

var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
var StateDefToken = /** @class */ (function (_super) {
    __extends(StateDefToken, _super);
    function StateDefToken() {
        return _super.call(this, 'StateDefToken') || this;
    }
    return StateDefToken;
}(core.InjectionToken));
/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
var ReduxSelectPipe = /** @class */ (function () {
    /**
     * @param {?=} stateDefs
     * @param {?=} injector
     */
    function ReduxSelectPipe(stateDefs, injector) {
        if (stateDefs === void 0) { stateDefs = []; }
        this.provider = /** @type {?} */ (injector.get(stateDefs[0].provider));
    }
    /**
     * @param {?} selector
     * @return {?}
     */
    ReduxSelectPipe.prototype.transform = function (selector) {
        return this.provider.select(selector);
    };
    return ReduxSelectPipe;
}());
ReduxSelectPipe.decorators = [
    { type: core.Pipe, args: [{ name: 'reduxSelect' },] },
];
/** @nocollapse */
ReduxSelectPipe.ctorParameters = function () { return [
    { type: Array, decorators: [{ type: core.Inject, args: [StateDefToken,] },] },
    { type: core.Injector, },
]; };
/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
/**
 * @record
 */
var Registry = /** @class */ (function () {
    function Registry() {
    }
    /**
     * @return {?}
     */
    Registry.reset = function () {
        Registry._store = new AsyncSubject.AsyncSubject();
        Registry._reducers = [];
    };
    /**
     * @param {?} store
     * @return {?}
     */
    Registry.registerStore = function (store) {
        Registry.reset();
        Registry._store.next(store);
        Registry._store.complete();
        reduxDecorators.ReduxActionDispatcher.dispatchedActions.subscribe(function (action) {
            store.dispatch(/** @type {?} */ (action));
        });
    };
    /**
     * @param {?} state
     * @return {?}
     */
    Registry.registerState = function (state) {
        Registry.getStore().then(function (store) {
            var /** @type {?} */ stateConfig = reduxDecorators.ReduxStateDecorator.get(state.constructor);
            var /** @type {?} */ initState = state.getInitialState();
            var /** @type {?} */ initStateToResolve = initState;
            if (initState instanceof Observable.Observable) {
                initStateToResolve = initState.toPromise();
            }
            Promise.resolve(initStateToResolve).then(function (initialState) {
                store.dispatch({
                    payload: {
                        initialValue: initialState,
                        name: stateConfig.name,
                    },
                    type: Registry.ACTION_REGISTER_STATE,
                });
            });
        });
    };
    /**
     * @return {?}
     */
    Registry.getStore = function () {
        return new Promise(Registry._store.subscribe.bind(Registry._store));
    };
    return Registry;
}());
Registry.ACTION_REGISTER_STATE = "@harmowatch/ngx-redux-core/registerState";
Registry._store = new AsyncSubject.AsyncSubject();
Registry._reducers = [];
/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
var ReduxSelector = /** @class */ (function (_super) {
    __extends(ReduxSelector, _super);
    /**
     * @param {?=} selector
     * @param {?=} stateProvider
     */
    function ReduxSelector(selector, stateProvider) {
        if (selector === void 0) { selector = '/'; }
        var _this = this;
        if (!selector.startsWith(ReduxSelector.DELIMITER) && !stateProvider) {
            throw new Error('You need to provide a state provider, if you use relative selectors');
        }
        _this = _super.call(this, 1) || this;
        Registry.getStore().then(function (store) {
            var /** @type {?} */ next = function () {
                _this.next(ReduxSelector.getValueByState(store.getState(), selector, stateProvider));
            };
            store.subscribe(function () { return next(); });
            next(); // we need to trigger a initial value, otherwise we've to wait until the first state change
        });
        return _this;
    }
    /**
     * @param {?} selector
     * @param {?=} stateProvider
     * @return {?}
     */
    ReduxSelector.normalize = function (selector, stateProvider) {
        if (!selector.startsWith(ReduxSelector.DELIMITER)) {
            return "/" + reduxDecorators.ReduxStateDecorator.get(stateProvider).name + "/" + selector;
        }
        return selector;
    };
    /**
     * @template S
     * @param {?} state
     * @param {?} selector
     * @param {?=} stateProvider
     * @return {?}
     */
    ReduxSelector.getValueByState = function (state, selector, stateProvider) {
        /* save the return value in a constant to prevent
             * "Metadata collected contains an error that will be reported at runtime: Lambda not supported."
             * error
             */
        var /** @type {?} */ value = ReduxSelector.normalize(selector, stateProvider).split(ReduxSelector.DELIMITER)
            .filter(function (propertyKey) { return propertyKey !== ''; })
            .reduce(function (previousValue, propertyKey) {
            if (!previousValue || !previousValue.hasOwnProperty(propertyKey)) {
                return null;
            }
            return previousValue[propertyKey];
        }, /** @type {?} */ (state));
        return value;
    };
    return ReduxSelector;
}(ReplaySubject.ReplaySubject));
ReduxSelector.DELIMITER = '/';
/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
/**
 * @abstract
 */
var ReduxStateProvider = /** @class */ (function () {
    /**
     * @param {?=} stateDefs
     */
    function ReduxStateProvider(stateDefs) {
        if (stateDefs === void 0) { stateDefs = []; }
        var _this = this;
        this.selectorCache = {};
        var _a = (reduxDecorators.ReduxStateDecorator.get(this.constructor) || {}).name, name = _a === void 0 ? null : _a;
        if (!name) {
            throw new Error('Unable to resolve state name! Make sure you\'ve decorated the provider by "@ReduxState"!');
        }
        this.name = reduxDecorators.ReduxStateDecorator.get(this.constructor).name;
        this.stateDef = stateDefs.find(function (def) { return reduxDecorators.ReduxStateDecorator.get(def.provider).name === name; });
        if (!this.stateDef) {
            throw new Error('Unable to resolve state definition! Make sure you\'ve registered the provider to ReduxModule!');
        }
        this.reducerMethodsByType = (this.stateDef.reducers || [])
            .map(function (clazz) { return _this.getReducerMethods(new clazz()); })
            .reduce(function (all, curr) { return [].concat(curr, all); }, []) // [].concat keeps the order, all.concat(curr) destroys the order
            .reduce(function (methodsByType, reducer) {
            var /** @type {?} */ type = getActionType(reducer.type);
            return Object.assign({}, methodsByType, (_a = {}, _a[type] = [reducer.method].concat(methodsByType[type] || []), _a));
            var _a;
        }, {});
        ReduxStateProvider.instancesByName[this.name] = this;
    }
    /**
     * @return {?}
     */
    ReduxStateProvider.prototype.getInitialState = function () {
        throw new Error('Method "getInitialState" not implemented.');
    };
    /**
     * @template T
     * @param {?=} selector
     * @return {?}
     */
    ReduxStateProvider.prototype.select = function (selector) {
        if (selector === void 0) { selector = ''; }
        var /** @type {?} */ stateType = (this.constructor);
        selector = ReduxSelector.normalize(selector, stateType);
        if (!this.selectorCache[selector]) {
            this.selectorCache[selector] = new ReduxSelector(selector, stateType).distinctUntilChanged();
        }
        return /** @type {?} */ (this.selectorCache[selector]);
    };
    /**
     * @template P
     * @param {?} state
     * @param {?} action
     * @return {?}
     */
    ReduxStateProvider.prototype.reduce = function (state, action) {
        var /** @type {?} */ reducerMethods = this.reducerMethodsByType[action.type] || [];
        return reducerMethods.reduce(function (stateToReduce, method) { return method(stateToReduce, action); }, state);
    };
    /**
     * @param {?} reducerClassInstance
     * @return {?}
     */
    ReduxStateProvider.prototype.getReducerMethods = function (reducerClassInstance) {
        return Object.values(Object.getPrototypeOf(reducerClassInstance))
            .map(function (method) {
            return {
                method: ((method)).bind(reducerClassInstance),
                type: reduxDecorators.ReduxReducerDecorator.get(method),
            };
        })
            .filter(function (type) { return type != null; })
            .reduce(function (all, curr) { return all.concat([].concat(curr.type).map(function (type) { return (Object.assign({}, curr, { type: type })); })); }, []);
    };
    return ReduxStateProvider;
}());
ReduxStateProvider.instancesByName = {};
/** @nocollapse */
ReduxStateProvider.ctorParameters = function () { return [
    { type: Array, decorators: [{ type: core.Inject, args: [StateDefToken,] },] },
]; };
/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
/**
 * @template S
 * @param {?} expression
 * @param {?=} context
 * @return {?}
 */
function ReduxSelect(expression, context) {
    return function (target, propertyKey) {
        var /** @type {?} */ originalOnInit = target['ngOnInit'];
        Object.defineProperty(target, 'ngOnInit', {
            value: function (injector) {
                var /** @type {?} */ stateName = reduxDecorators.ReduxStateDecorator.get(context).name;
                Object.defineProperty(target, propertyKey, {
                    value: ReduxStateProvider.instancesByName[stateName].select(expression)
                });
                if (originalOnInit) {
                    originalOnInit.apply(target, arguments);
                }
            }
        });
    };
}
/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
var ReduxState = reduxDecorators.ReduxStateDecorator.forClass;
/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
var ReduxStore = /** @class */ (function (_super) {
    __extends(ReduxStore, _super);
    function ReduxStore() {
        return _super.call(this, 'ReduxStore') || this;
    }
    return ReduxStore;
}(core.InjectionToken));
/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
var ReduxCommonModule = /** @class */ (function () {
    function ReduxCommonModule() {
    }
    return ReduxCommonModule;
}());
ReduxCommonModule.decorators = [
    { type: core.NgModule, args: [{
                declarations: [
                    ReduxSelectPipe,
                ],
                exports: [
                    ReduxSelectPipe,
                ],
            },] },
];
/** @nocollapse */
ReduxCommonModule.ctorParameters = function () { return []; };
/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
var ReduxTestingStore = /** @class */ (function () {
    function ReduxTestingStore() {
        this.state = new BehaviorSubject.BehaviorSubject(null);
    }
    /**
     * @template S
     * @param {?} state
     * @param {?} value
     * @return {?}
     */
    ReduxTestingStore.prototype.setState = function (state, value) {
        var _this = this;
        var name = reduxDecorators.ReduxStateDecorator.get(state).name;
        var /** @type {?} */ nextState = Object.assign({}, this.state.getValue(), (_a = {}, _a[name] = value, _a));
        this.state.next(nextState);
        return this.state
            .takeWhile(function (currentState) { return currentState !== nextState; })
            .toPromise().then(function () { return _this.state.getValue(); });
        var _a;
    };
    /**
     * @return {?}
     */
    ReduxTestingStore.prototype.getState = function () {
        return this.state.getValue();
    };
    /**
     * @param {?} listener
     * @return {?}
     */
    ReduxTestingStore.prototype.subscribe = function (listener) {
        return this.state.subscribe.call(this.state, listener);
    };
    /**
     * @return {?}
     */
    ReduxTestingStore.prototype.replaceReducer = function () {
    };
    /**
     * @template T
     * @param {?} action
     * @return {?}
     */
    ReduxTestingStore.prototype.dispatch = function (action) {
        return action;
    };
    return ReduxTestingStore;
}());
ReduxTestingStore.decorators = [
    { type: core.Injectable },
];
/** @nocollapse */
ReduxTestingStore.ctorParameters = function () { return []; };
/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
var ReduxTestingModule = /** @class */ (function () {
    /**
     * @param {?=} store
     */
    function ReduxTestingModule(store) {
        if (store === void 0) { store = null; }
        if (store) {
            Registry.reset();
            Registry.registerStore(store);
        }
    }
    /**
     * @param {?=} config
     * @return {?}
     */
    ReduxTestingModule.forRoot = function (config) {
        if (config === void 0) { config = {}; }
        return {
            ngModule: ReduxTestingModule,
            providers: [
                { provide: ReduxTestingStore, useFactory: config.storeFactory || ReduxTestingModule.defaultStoreFactory },
                { provide: StateDefToken, useValue: config.state || null, multi: true },
            ],
        };
    };
    /**
     * @return {?}
     */
    ReduxTestingModule.defaultStoreFactory = function () {
        return new ReduxTestingStore();
    };
    return ReduxTestingModule;
}());
ReduxTestingModule.decorators = [
    { type: core.NgModule, args: [{
                exports: [
                    ReduxCommonModule,
                ],
                imports: [
                    common.CommonModule,
                ],
                providers: [
                    ReduxTestingStore,
                ],
            },] },
];
/** @nocollapse */
ReduxTestingModule.ctorParameters = function () { return [
    { type: undefined, decorators: [{ type: core.Optional }, { type: core.Inject, args: [ReduxTestingStore,] },] },
]; };
/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
var ReducerProvider = /** @class */ (function () {
    function ReducerProvider() {
        this.stateProviders = {};
    }
    /**
     * @param {?} provider
     * @return {?}
     */
    ReducerProvider.prototype.addStateProvider = function (provider) {
        if (!this.stateProviders[provider.name]) {
            Registry.registerState(provider);
            this.stateProviders[provider.name] = provider;
        }
    };
    /**
     * @param {?} rootState
     * @param {?} action
     * @return {?}
     */
    ReducerProvider.prototype.reduce = function (rootState, action) {
        if (action.type === Registry.ACTION_REGISTER_STATE) {
            var /** @type {?} */ regAction = (((action)));
            return Object.assign({}, rootState, (_a = {}, _a[regAction.payload.name] = regAction.payload.initialValue, _a));
        }
        return Object.values(this.stateProviders).reduce(function (stateToReduce, provider) {
            return Object.assign({}, stateToReduce, (_a = {}, _a[provider.name] = provider.reduce(stateToReduce[provider.name], action), _a));
            var _a;
        }, rootState);
        var _a;
    };
    return ReducerProvider;
}());
ReducerProvider.decorators = [
    { type: core.Injectable },
];
/** @nocollapse */
ReducerProvider.ctorParameters = function () { return []; };
/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
var ReduxRootModule = /** @class */ (function () {
    /**
     * @param {?=} store
     * @param {?=} reducer
     * @param {?=} injector
     * @param {?=} stateDefs
     */
    function ReduxRootModule(store, reducer, injector, stateDefs) {
        if (store === void 0) { store = null; }
        if (stateDefs === void 0) { stateDefs = []; }
        var _this = this;
        this.reducer = reducer;
        this.injector = injector;
        Registry.registerStore(store);
        stateDefs
            .filter(function (def) { return def && def.provider; })
            .map(function (def) { return _this.injector.get(def.provider); })
            .forEach(function (provider) { return _this.reducer.addStateProvider(provider); });
    }
    return ReduxRootModule;
}());
ReduxRootModule.decorators = [
    { type: core.NgModule, args: [{
                exports: [
                    ReduxCommonModule,
                ],
                imports: [
                    common.CommonModule,
                ],
            },] },
];
/** @nocollapse */
ReduxRootModule.ctorParameters = function () { return [
    { type: undefined, decorators: [{ type: core.Inject, args: [ReduxStore,] },] },
    { type: ReducerProvider, },
    { type: core.Injector, },
    { type: Array, decorators: [{ type: core.Optional }, { type: core.Inject, args: [StateDefToken,] },] },
]; };
var ReduxModule = /** @class */ (function () {
    /**
     * @param {?=} stateDefs
     * @param {?=} reducer
     * @param {?=} injector
     */
    function ReduxModule(stateDefs, reducer, injector) {
        if (stateDefs === void 0) { stateDefs = []; }
        var _this = this;
        this.reducer = reducer;
        this.injector = injector;
        stateDefs
            .filter(function (def) { return def && def.provider; })
            .map(function (def) { return _this.injector.get(def.provider); })
            .forEach(function (provider) { return _this.reducer.addStateProvider(provider); });
    }
    /**
     * @param {?=} config
     * @return {?}
     */
    ReduxModule.forChild = function (config) {
        if (config === void 0) { config = {}; }
        return {
            ngModule: ReduxModule,
            providers: [
                { provide: StateDefToken, useValue: config.state || null, multi: true },
            ],
        };
    };
    /**
     * @param {?=} config
     * @return {?}
     */
    ReduxModule.forRoot = function (config) {
        if (config === void 0) { config = {}; }
        return {
            ngModule: ReduxRootModule,
            providers: [
                ReducerProvider,
                {
                    provide: ReduxStore,
                    useFactory: config.storeFactory || ReduxModule.defaultStoreFactory,
                    deps: [ReducerProvider]
                },
                { provide: StateDefToken, useValue: config.state || null, multi: true },
            ],
        };
    };
    /**
     * @param {?} reducer
     * @return {?}
     */
    ReduxModule.defaultStoreFactory = function (reducer) {
        return redux.createStore(reducer.reduce.bind(reducer), {}, ReduxModule.defaultEnhancerFactory());
    };
    /**
     * @return {?}
     */
    ReduxModule.defaultEnhancerFactory = function () {
        if (console && window['__REDUX_DEVTOOLS_EXTENSION__'] && core.isDevMode()) {
            return window['__REDUX_DEVTOOLS_EXTENSION__']();
        }
        return ReduxModule.noopEnhancer;
    };
    /**
     * @param {?} next
     * @return {?}
     */
    ReduxModule.noopEnhancer = function (next) {
        return next;
    };
    return ReduxModule;
}());
ReduxModule.decorators = [
    { type: core.NgModule, args: [{
                exports: [
                    ReduxCommonModule,
                ],
                imports: [
                    common.CommonModule,
                ],
            },] },
];
/** @nocollapse */
ReduxModule.ctorParameters = function () { return [
    { type: Array, decorators: [{ type: core.Optional }, { type: core.Inject, args: [StateDefToken,] },] },
    { type: ReducerProvider, },
    { type: core.Injector, },
]; };
/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
var ReduxAction = reduxDecorators.ReduxActionDecorator.forMethod;
var ReduxActionContext = reduxDecorators.ReduxActionContextDecorator.forClass;
var getActionType = reduxDecorators.ReduxActionDispatcher.getType;
var ReduxReducer = reduxDecorators.ReduxReducerDecorator.forMethod;
/**
 * @record
 */
/**
 * interface doesn't work \@see https://github.com/angular/angular-cli/issues/2034#issuecomment-302666897 :/
 * @deprecated Please use ActionWithPayload instead
 */
var ActionInterface = /** @class */ (function () {
    function ActionInterface() {
    }
    return ActionInterface;
}());

exports.ReduxAction = ReduxAction;
exports.ReduxActionContext = ReduxActionContext;
exports.getActionType = getActionType;
exports.ReduxReducer = ReduxReducer;
exports.ActionInterface = ActionInterface;
exports.ReduxSelect = ReduxSelect;
exports.ReduxSelectPipe = ReduxSelectPipe;
exports.ReduxState = ReduxState;
exports.ReduxStore = ReduxStore;
exports.ReduxTestingModule = ReduxTestingModule;
exports.ReduxTestingStore = ReduxTestingStore;
exports.ReduxSelector = ReduxSelector;
exports.ReduxStateProvider = ReduxStateProvider;
exports.ReduxRootModule = ReduxRootModule;
exports.ReduxModule = ReduxModule;
exports.ɵb = ReduxCommonModule;
exports.ɵc = ReducerProvider;
exports.ɵa = StateDefToken;

Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=harmowatch-ngx-redux-core.umd.js.map
