import { ReduxActionContextDecorator, ReduxActionDecorator, ReduxActionDispatcher, ReduxReducerDecorator } from '@harmowatch/redux-decorators';
import { Action } from 'redux';
export * from './module/public_api';
export * from './select/public_api';
export * from './state/public_api';
export * from './store/public_api';
export * from './testing/public_api';
export * from './selector/selector';
export * from './state/state.provider';
export * from './module';
export { ReduxActionFunction, ReduxReducerType, ReduxStateType as ReduxStateProviderType } from '@harmowatch/redux-decorators';
export declare const ReduxAction: typeof ReduxActionDecorator.forMethod;
export declare const ReduxActionContext: typeof ReduxActionContextDecorator.forClass;
export declare const getActionType: typeof ReduxActionDispatcher.getType;
export declare const ReduxReducer: typeof ReduxReducerDecorator.forMethod;
export interface ActionWithPayload<P = void> extends Action {
    type: string;
    payload?: P;
}
/**
 * interface doesn't work @see https://github.com/angular/angular-cli/issues/2034#issuecomment-302666897 :/
 * @deprecated Please use ActionWithPayload instead
 */
export declare class ActionInterface<P = void> {
    type: string;
    payload?: P;
}
