import { Injector, ModuleWithProviders } from '@angular/core';
import { Store, StoreEnhancer, StoreEnhancerStoreCreator } from 'redux';
import { ReducerProvider } from './reducer/reducer.provider';
import { ReduxModuleChildConfig } from './module/child/config';
import { ReduxModuleRootConfig } from './module/root/config';
import { StateDefinition } from './state/definition';
export declare class ReduxRootModule {
    private reducer;
    private injector;
    constructor(store: Store<{}>, reducer: ReducerProvider, injector: Injector, stateDefs?: StateDefinition[]);
}
export declare class ReduxModule {
    private reducer;
    private injector;
    constructor(stateDefs: StateDefinition[], reducer: ReducerProvider, injector: Injector);
    static forChild(config?: ReduxModuleChildConfig): ModuleWithProviders;
    static forRoot(config?: ReduxModuleRootConfig): ModuleWithProviders;
    static defaultStoreFactory(reducer: ReducerProvider): Store<{}>;
    static defaultEnhancerFactory(): StoreEnhancer<{}>;
    static noopEnhancer(next: StoreEnhancerStoreCreator<{}>): StoreEnhancerStoreCreator<{}>;
}
