import 'rxjs/add/operator/distinctUntilChanged';
import { ReduxStateInterface } from '@harmowatch/redux-decorators';
import { ActionWithPayload } from '../';
import { StateDefinition } from '../state/definition';
import { Observable } from 'rxjs/Observable';
export declare abstract class ReduxStateProvider<S> implements ReduxStateInterface<S> {
    static instancesByName: {
        [stateName: string]: ReduxStateProvider<{}>;
    };
    readonly name: string;
    readonly stateDef: StateDefinition;
    protected selectorCache: {
        [selector: string]: Observable<{}>;
    };
    protected reducerMethodsByType: {
        [actionType: string]: Function[];
    };
    constructor(stateDefs?: StateDefinition[]);
    getInitialState(): S | Promise<S> | Observable<S>;
    select<T>(selector?: string): Observable<T>;
    reduce<P>(state: S, action: ActionWithPayload<P>): any;
    private getReducerMethods(reducerClassInstance);
}
